<?php
if (!function_exists('laracvs_asset')) {
    function laracvs_asset($path)
    {
        return asset('public/static/' . $path);
    }
}
if (!function_exists('laracvs')) {
    function laracvs($path)
    {
        $data = config($path);
        return $data;
    }
}

if (!function_exists('laracvs_type')) {
    function laracvs_type($path)
    {
        $data = config('vtype' . '.' . $path);
        return $data;
    }
}

if (!function_exists('laracvs_mobile')) {
    function laracvs_mobile($csum, $msum)
    {
        if (is_mobile()) {
            return $msum;
        } else {
            return $csum;
        }
    }
}

function is_mobile()
{
    // 如果有HTTP_X_WAP_PROFILE则一定是移动设备
    if (isset($_SERVER['HTTP_X_WAP_PROFILE'])) {
        return true;
    }
    // 如果via信息含有wap则一定是移动设备,部分服务商会屏蔽该信息
    if (isset($_SERVER['HTTP_VIA'])) {
        // 找不到为flase,否则为true
        return stristr($_SERVER['HTTP_VIA'], "wap") ? true : false;
    }
    // 脑残法，判断手机发送的客户端标志,兼容性有待提高。其中'MicroMessenger'是电脑微信
    if (isset($_SERVER['HTTP_USER_AGENT'])) {
        $clientkeywords = array('nokia', 'sony', 'ericsson', 'mot', 'samsung', 'htc', 'sgh', 'lg', 'sharp', 'sie-', 'philips', 'panasonic', 'alcatel', 'lenovo', 'iphone', 'ipod', 'blackberry', 'meizu', 'android', 'netfront', 'symbian', 'ucweb', 'windowsce', 'palm', 'operamini', 'operamobi', 'openwave', 'nexusone', 'cldc', 'midp', 'wap', 'mobile', 'MicroMessenger');
        // 从HTTP_USER_AGENT中查找手机浏览器的关键字
        if (preg_match("/(" . implode('|', $clientkeywords) . ")/i", strtolower($_SERVER['HTTP_USER_AGENT']))) {
            return true;
        }
    }
    // 协议法，因为有可能不准确，放到最后判断
    if (isset ($_SERVER['HTTP_ACCEPT'])) {
        // 如果只支持wml并且不支持html那一定是移动设备
        // 如果支持wml和html但是wml在html之前则是移动设备
        if ((strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') !== false) && (strpos($_SERVER['HTTP_ACCEPT'], 'text/html') === false || (strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') < strpos($_SERVER['HTTP_ACCEPT'], 'text/html')))) {
            return true;
        }
    }
    return false;
}

if (!function_exists('laracvs_array_last')) {
    function laracvs_array_last($url)
    {
        $str = str_replace(['http://','https://'],'',$url);
        $arr = explode('/',$str);
        $lastdata = array_last($arr,function ($value,$key){
              return $value!="";
        });
        $lastdata = substr(md5($lastdata),'7','5');
        return $lastdata;
    }
}

if (!function_exists('laracvs_interface')) {
    function laracvs_interface()
    {
           $interface = config('interface');
           return $interface;
    }
}

if (!function_exists('laracvs_page')) {
    function laracvs_page($pg)
    {   $num = $pg/5;
        if (is_int($num)){
            $star = $pg;
            $end = 5*($num+1);
        }else{
            $star = intval($num)==0?1:intval($num)*5;
            $end  = 5*(intval($num)+1);
        }

        return ['start'=>$star,'end'=>$end];
    }
}

if (!function_exists('laracvs_qrcode')) {
    function laracvs_qrcode()
    {   $host = "http://".$_SERVER['HTTP_HOST'];
        $request = $_SERVER['REQUEST_URI'];
        $url=$host.$request;
        $img = 'http://qr.liantu.com/api.php?text='.$url;
        echo $img;
    }
}

if (!function_exists('laracvs_link')) {
    function laracvs_link()
    {
        $link = new \App\Link();
        $linklist = $link->all();
        return $linklist;
    }
}

if (!function_exists('laracvs_qq')) {
    function laracvs_qq()
    {
        $qq = new \App\Larqq();
        $qqlist = $qq->all();
        return $qqlist;
    }
}

if (!function_exists('laracvs_ad')) {
    function laracvs_ad($num)
    {
        return config('ads.ad'.$num);
    }
}




